#define VERMAJOR 1
#define VERMINOR 0
#define VERPATCH 150712

#include once "fbgfx.bi"
#include once "inc/xmlparse.bi"
#include once "inc/mdLanguage.bi"
#include once "inc/multiput.bi"
#include once "crt/string.bi"
#include once "inc/TSNE_V3.bi"

dim as string language = "deutsch"
loadCustomLanguage(l, language, exepath & "/lang/", "", "")

#include once "inc/mages.bi"

'###############################################################################
' NETWORK
'
dim shared serverID as integer, mutex as any ptr, dataBuffer as string
mutex = mutexcreate

declare sub TSNE_Disconnected(byval V_TSNEID as uinteger)
declare sub TSNE_Connected(byval V_TSNEID as UInteger)
declare sub TSNE_NewData(byval V_TSNEID as uinteger, byref V_Data as string)

type connectionType
  as uinteger G_Client
  declare constructor
  declare constructor(ip as string, port as integer)
  declare destructor
  declare sub shutdown
  declare sub send(msg as string)
  declare sub sendCommand(msg as TCommand, txt as string = "")
end type

constructor connectionType
end constructor
constructor connectionType(ip as string, port as integer)
  dim RV as integer
  RV = TSNE_Create_Client(G_Client, ip, port, @TSNE_Disconnected, @TSNE_Connected, @TSNE_NewData) ' create Client
  if RV = TSNE_Const_NoError then
    print "searching for server"
  else
    print "ERROR: " & RV
  end if
end constructor

destructor connectionType
  shutdown
end destructor

sub connectionType.shutdown
  TSNE_Disconnect(G_Client)
  TSNE_WaitClose(G_Client)
end sub

sub connectionType.send(msg as string)
  mutexlock mutex
  TSNE_Data_Send(serverID, msg)
  mutexunlock mutex
end sub

sub connectionType.sendCommand(msg as TCommand, txt as string = "")
  this.send chr(msg) & txt
end sub

'###############################################################################

declare sub appear overload(p as TPlayer, o as TPlayer, c as TCard, tnumb as integer, gray as integer = 0)
declare sub appear(p as TPlayer, o as TPlayer, cnumb as integer, tnumb as integer, gray as integer = 0)
declare sub appear(tnumb as integer, gray as integer, img as FB.Image ptr)
declare function cardImg(c as TCard, player as TPlayer, opponent as TPlayer, number as integer) as FB.Image ptr
declare sub cardInfo(c as TCard ptr)
declare function cardInfoText(effect as TEffect, showAlt as integer = 0) as string
declare sub center overload (x as integer, byref y as integer, s as string, col as uinteger = &hffffff, _
           max_ as integer = 45, spacing as integer = 10)
declare sub center(img as FB.Image ptr, x as integer, byref y as integer, s as string, col as uinteger = &hffffff, _
           max_ as integer = 45, spacing as integer = 10)
declare function colorOfEffect(eff as TEffectType) as uinteger
declare sub drawScreen(player as TPlayer, opponent as TPlayer, spec as integer)
declare sub makeTurn(player as TPlayer, opponent as TPlayer, tablenumber as integer, spec as integer)
declare sub move(cardnumber as integer, tablenumber as integer)
declare function playable(player as TPlayer, cardnumber as integer, spec as integer) as integer
declare function playCard(player as TPlayer, cardnumber as integer, spec as integer) as integer
declare function readMessageData as string

dim shared as connectionType myClient = connectionType("127.0.0.1", 6006)
dim as string message, tempString
dim as integer countCards, id
dim as TPlayer player, opponent
dim as string filename = dir(exepath & "/cards/*.xml")
do while len(filename)
  readCards(player, filename, language)
  filename = dir
loop

with setting
  .waitBeforeDisplay = 1000
  .waitAfterDisplay  = 3000
  ' pattern of tower and wall
  tempString = chr(  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0) _
             & chr(  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0) _
             & chr(  0,  0,  0,  0, 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0) _
             & chr( 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0) _
             & chr(  0,  0,  0,  0, 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0) _
             & chr( 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0) _
             & chr(  0,  0,  0,  0, 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0) _
             & chr( 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0) _
             & chr(  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0) _
             & chr(  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0) _
             & chr( 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0) _
             & chr(  0,  0,  0,  0, 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0) _
             & chr( 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0) _
             & chr(  0,  0,  0,  0, 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0) _
             & chr( 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0) _
             & chr(  0,  0,  0,  0, 85, 85, 85,  0, 85, 85, 85,  0, 85, 85, 85,  0)
  .fillTower = tempString
  tempString = chr(  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0) _
             & chr(  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0) _
             & chr(  0,  0,  0,  0,  0,127,255,  0,  0,127,255,  0,  0,127,255,  0) _
             & chr(  0,  0,  0,  0,  0,127,255,  0,  0,127,255,  0,  0,127,255,  0) _
             & chr(  0,  0,  0,  0,  0,127,255,  0,  0,127,255,  0,  0,127,255,  0) _
             & chr(  0,  0,  0,  0,  0,127,255,  0,  0,127,255,  0,  0,127,255,  0) _
             & chr(  0,  0,  0,  0,  0,127,255,  0,  0,127,255,  0,  0,127,255,  0) _
             & chr(  0,  0,  0,  0,  0,127,255,  0,  0,127,255,  0,  0,127,255,  0) _
             & chr(  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0) _
             & chr(  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0) _
             & chr(  0,127,255,  0,  0,127,255,  0,  0,  0,  0,  0,  0,127,255,  0) _
             & chr(  0,127,255,  0,  0,127,255,  0,  0,  0,  0,  0,  0,127,255,  0) _
             & chr(  0,127,255,  0,  0,127,255,  0,  0,  0,  0,  0,  0,127,255,  0) _
             & chr(  0,127,255,  0,  0,127,255,  0,  0,  0,  0,  0,  0,127,255,  0) _
             & chr(  0,127,255,  0,  0,127,255,  0,  0,  0,  0,  0,  0,127,255,  0) _
             & chr(  0,127,255,  0,  0,127,255,  0,  0,  0,  0,  0,  0,127,255,  0)
  .fillWall = tempString
end with
screenres 800, 600, 32, 2
windowtitle "Mages (v" & VERMAJOR & "." & VERMINOR & ")"
print "waiting for server response ..."

dim as integer spec, whoson = -1, tablenumber
dim shared as FB.Image ptr grayImg, playedCards
grayImg = imagecreate(100, 140, rgba(0, 0, 0, 127))
playedCards = imagecreate(500, 450)
'##########################################################################
' START THE GAME
do
  message &= readMessageData
  if len(message) then
    select case message[0]
      case TCommand.connectionLost
        print "ERROR: Connection lost"
        exit do
' Client gets current game settings
      case TCommand.submitSettings
        if len(message) < 2 then
          myClient.sendCommand TCommand.fault
          message = ""
          continue do
        end if
        countCards = message[1]
        if countCards > MAXCARDS or len(message) < countCards*2 + 37 then
          myClient.sendCommand TCommand.fault
          message = ""
          continue do
        end if
        for i as integer = 0 to countCards-1
          id = (message[i*2+2] shl 8) + message[i*2+3]
          for k as integer = 0 to ubound(player.deck)
            if player.deck(k).id = id then
              player.card(i) = k
              exit for
            end if
          next
        next
        player.stone     = (message[countCards*2+2] shl 7) + message[countCards*2+3]
        player.pStone    = message[countCards*2+4]
        player.crystal   = (message[countCards*2+5] shl 7) + message[countCards*2+6]
        player.pCrystal  = message[countCards*2+7]
        player.creature  = (message[countCards*2+8] shl 7) + message[countCards*2+9]
        player.pCreature = message[countCards*2+10]
        player.tower     = (message[countCards*2+11] shl 7) + message[countCards*2+12]
        player.wall      = (message[countCards*2+13] shl 7) + message[countCards*2+14]
        opponent.stone     = (message[countCards*2+15] shl 7) + message[countCards*2+16]
        opponent.pStone    = message[countCards*2+17]
        opponent.crystal   = (message[countCards*2+18] shl 7) + message[countCards*2+19]
        opponent.pCrystal  = message[countCards*2+20]
        opponent.creature  = (message[countCards*2+21] shl 7) + message[countCards*2+22]
        opponent.pCreature = message[countCards*2+23]
        opponent.tower     = (message[countCards*2+24] shl 7) + message[countCards*2+25]
        opponent.wall      = (message[countCards*2+26] shl 7) + message[countCards*2+27]
        setting.maxStone    = (message[countCards*2+28] shl 7) + message[countCards*2+29]
        setting.maxCrystal  = (message[countCards*2+30] shl 7) + message[countCards*2+31]
        setting.maxCreature = (message[countCards*2+32] shl 7) + message[countCards*2+33]
        setting.maxTower    = (message[countCards*2+34] shl 7) + message[countCards*2+35]
        spec                = message[countCards*2+36]
        message = mid(message, countCards*2+38)
        drawScreen(player, opponent, spec)
' client gets command to play or to wait
      case TCommand.yourTurn
        message = mid(message, 2)
        if whoson <> 0 then
          whoson = 0
          tablenumber = 0
        else
          tablenumber += 1
        end if
        makeTurn player, opponent, tablenumber, spec
      case TCommand.wait4turn
        message = mid(message, 2)
        if setting.waitBeforeDisplay > 0 then sleep setting.waitBeforeDisplay
        if whoson <> 1 then
          whoson = 1
          tablenumber = 0
        else
          tablenumber += 1
        end if
        line (210, 350)-step(380, 99), 0, bf
        center 400, 355, getTranslation(l, "infoOpponentsTurn")
' client gets a new card
      case TCommand.takeCard
        if len(message) < 4 then
          myClient.sendCommand TCommand.fault
          message = ""
          continue do
        end if
        id = (message[2] shl 8) + message[3]
        for i as integer = 0 to ubound(player.deck)
          if player.deck(i).id = id then player.card(message[1]) = i : exit for
        next
        appear player, opponent, message[1], -message[1], iif(playable(player, message[1], spec), 0, -1)
        message = mid(message, 5)
' opponent plays or drops a card
      case TCommand.playCard, TCommand.dropCard
        if len(message) < 3 then
          myClient.sendCommand TCommand.fault
          message = ""
          continue do
        end if
        if tablenumber = 0 then
          line playedCards, (0, 0)-step(499, 449), &hff00ff, bf
          drawScreen player, opponent, spec
        end if
        id = (message[1] shl 8) + message[2]
        for i as integer = 0 to ubound(player.deck)
          if player.deck(i).id = id then
            appear opponent, player, player.deck(i), tablenumber, iif(message[0] = TCommand.playCard, 0, -1)
          end if
        next
        message = mid(message, 4)
' game ends
      case TCommand.gameWin
        center 400, 296, getTranslation(l, "messageWin")
        getkey
        exit do
      case TCommand.gameLose
        center 400, 296, getTranslation(l, "messageLose")
        getkey
        exit do
      case TCommand.gameDraw
        center 400, 296, getTranslation(l, "messageDraw")
        getkey
        exit do
' unknown command
      case else
        dim as integer i
        for i = 1 to len(message)-1
          if message[i] > 127 then exit for
        next
        message = mid(message, i+1)
    end select
  end if
loop until inkey = chr(255, 107)

myClient.shutdown
'threadwait serverthread
mutexdestroy mutex
end

' destruct
imagedestroy grayImg
imagedestroy playedCards

sub TSNE_Disconnected(byval V_TSNEID as uinteger)
  mutexlock mutex
  dataBuffer = chr(TCommand.connectionLost)
  mutexunlock mutex
end sub

sub TSNE_Connected(byval V_TSNEID as uinteger)
  mutexlock mutex
  serverID = V_TSNEID
  mutexunlock mutex
end sub

sub TSNE_NewData(byval V_TSNEID as uinteger, byref V_Data as string)
  mutexlock mutex
  dataBuffer &= V_Data
  mutexunlock mutex
end sub


sub appear(p as TPlayer, o as TPlayer, c as TCard, tnumb as integer, gray as integer = 0)
  dim as FB.Image ptr img = cardImg(c, o, p, 2)
  appear tnumb, gray, img
  imagedestroy img
end sub

sub appear(p as TPlayer, o as TPlayer, cnumb as integer, tnumb as integer, gray as integer = 0)
  dim as FB.Image ptr img = cardImg(p.deck(p.card(cnumb)), p, o, 1)
  appear tnumb, gray, img
  imagedestroy img
end sub

sub appear(tnumb as integer, gray as integer, img as FB.Image ptr)
  dim as integer posX, posY
  if gray then put img, (0, 0), grayImg, alpha
  if tnumb < 0 then
    posX = 149-tnumb*100
    posY = 520
  else
    posX = 200 + 100*(tnumb mod 5)
    posY = 80 + 25*(tnumb \ 5)
    put playedCards, (posX-200, posY-80), img, pset
  end if
  for i as integer = 1 to 100
    multiPut , posX, posY, img, 1, i/100
    sleep 1
  next
  put (posX - 50, posY - 70), img, pset
end sub

function cardImg(c as TCard, player as TPlayer, opponent as TPlayer, number as integer) as FB.Image ptr
  dim as FB.Image ptr img = imagecreate(100, 140, 0)
  dim as uinteger col
  dim as integer posX = 51, posY = 65, spacing = 20, spec = 0
  dim as string tempString
  dim as TPlayer playerNew(1 to 2) = {player, opponent}
  with c
    select case .costType
      case TCond.ownStone
        col = ColorStone
        playerNew(number).stone    -= .cost
      case TCond.ownCrystal
        col = ColorCrystal
        playerNew(number).crystal  -= .cost
      case TCond.ownCreature
        col = ColorCreature
        playerNew(number).creature -= .cost
      case else
        col = &hffffff
    end select
    line img, (2, 0)-step(96, 139), col, b
    line img, (3, 1)-step(92, 137), 0, bf
    center img, posX, 5, .cardname
    center img, posX, 25, getTranslation(l, "cost") & " " & .cost, col
    for i as integer = 0 to MAXEFFECTS - 1
      if .effect(i).effectType = TEffectType.none then continue for
      dim as string arr1 = "", arr2 = "", sign = "", text = ""
      dim as integer value = .effect(i).power
      dim as TEffectType effectType
      if .effect(i).cond1 <> TCond.none then spec = -1
      if testCondition(player, opponent, .effect(i)) then
        effectType = .effect(i).effectType
        value = calcRelation(playerNew(1), playerNew(2), .effect(i).power, .effect(i).relation)
      else
        effectType = .effect(i).effectTypeAlt
        value = calcRelation(playerNew(1), playerNew(2), .effect(i).powerAlt, .effect(i).relatAlt)
      end if
      if value = 0 then continue for
      col = colorOfEffect(effectType)
      ' arrows
      select case effectType
        case changeOwnStone, changeOwnCrystal, changeOwnCreature, _
             changeOwnStoneProd, changeOwnCrystalProd, changeOwnCreatureProd
          if number = 1 then arr1 = "< " else arr2 = " >"
          if value > 0 then sign = "+"
        case changeOppStone, changeOppCrystal, changeOppCreature, _
             changeOppStoneProd, changeOppCrystalProd, changeOppCreatureProd
          if number = 1 then arr2 = " >" else arr1 = "< "
          if value > 0 then sign = "+"
        case changeBothStone, changeBothCrystal, changeBothCreature
          arr1 = "< " : arr2 = " >"
          if value > 0 then sign = "+"
        case changeBothStoneProd, changeBothCrystalProd, changeBothCreatureProd
          arr1 = "<" : arr2 = " >"
          if value > 0 then sign = "+"
        case changeOwnWall, changeOwnTower, ownDamage
          if number = 1 then arr1 = "< " else arr2 = " >"
        case changeOppWall, changeOppTower, oppDamage
          if number = 1 then arr2 = " >" else arr1 = "< "
        case changeBothWall, changeBothTower, bothDamage
          arr1 = "<" : arr2 = " >"
        case stealStone, stealCrystal, stealCreature, stealStoneProd, stealCrystalProd, stealCreatureProd
          if value > 0 xor number = 2 then
            arr1 = "< " : arr2 = " <"
          else
            arr1 = "> " : arr2 = " >"
          end if
          value = abs(value)
      end select
      ' additional text
      select case effectType
        case changeOwnStoneProd,  changeOwnCrystalProd,  changeOwnCreatureProd, _
             changeOppStoneProd,  changeOppCrystalProd,  changeOppCreatureProd, _
             changeBothStoneProd, changeBothCrystalProd, changeBothCreatureProd, _
             stealStoneProd,      stealCrystalProd,      stealCreatureProd
          text = " " & getTranslation(l, "prod")
        case changeOwnWall, changeOppWall, changeBothWall
          text = " " & getTranslation(l, "wall")
        case changeOwnTower, changeOppTower, changeBothTower
          text = " " & getTranslation(l, "tower")
        case ownDamage, oppDamage, bothDamage
          text = " " & getTranslation(l, "damage")
      end select
      center img, posX, posY, arr1 & sign & value & text & arr2, col
      posY += spacing
      calcEffect(playerNew(1), playerNew(2), .effect(i))
    next
    if spec then
      center img, posX, posY, getTranslation(l, "special")
      posY += spacing
    end if
    if .special and Special.again then
      select case .special and (Special.stone or Special.crystal or Special.creature)
        case Special.stone    : col = ColorStone
        case Special.crystal  : col = ColorCrystal
        case Special.creature : col = ColorCreature
        case else             : col = &hffffff
      end select
      center img, posX, posY, getTranslation(l, "againShort"), col
      posY += spacing
    end if
  end with
  return img
end function

sub cardInfo(c as TCard ptr)
  line (210, 350)-step(380, 99), 0, bf
  if c = 0 then exit sub
  dim as integer posX = 400, posY = 375, spacing = 15, shortSpacing = 10, cost
  dim as string res
  select case c->costType
    case TCond.ownStone    : res = "stones"
    case TCond.ownCrystal  : res = "crystals"
    case TCond.ownCreature : res = "creatures"
  end select
  center 400, 355, removeNewline(c->cardname) & " (" & c->cost & " " & getTranslation(l, res) & ")"

  if len(c->desc) then
    center posX, posY, c->desc
  else
    for i as integer = 0 to c->countEffects - 1
      if c->effect(i).cond1 = TCond.none then
        center posX, posY, cardInfoText(c->effect(i))
        posY += spacing
      else
        dim as string cnd1, cnd2, cmp, res
        select case c->effect(i).cond1
          case TCond.ownStone,    TCond.ownStoneProd,    TCond.oppStone,    TCond.oppStoneProd
            res = getTranslation(l, "stones")
          case TCond.ownCrystal,  TCond.ownCrystalProd,  TCond.oppCrystal,  TCond.oppCrystalProd
            res = getTranslation(l, "crystals")
          case TCond.ownCreature, TCond.ownCreatureProd, TCond.oppCreature, TCond.oppCreatureProd
            res = getTranslation(l, "creatures")
        end select
        select case c->effect(i).cond1
          case TCond.ownStone, TCond.ownCrystal, TCond.ownCreature
            cnd1 = getTranslation(l, "ownResources", res)
          case TCond.ownStoneProd, TCond.ownCrystalProd, TCond.ownCreatureProd
            cnd1 = getTranslation(l, "ownProduction", res)
          case TCond.ownWall
            cnd1 = getTranslation(l, "ownWall")
          case TCond.ownTower
            cnd1 = getTranslation(l, "ownTower")
          case TCond.oppStone, TCond.oppCrystal, TCond.oppCreature
            cnd1 = getTranslation(l, "opponentResources", res)
          case TCond.oppStoneProd, TCond.oppCrystalProd, TCond.oppCreatureProd
            cnd1 = getTranslation(l, "opponentProduction", res)
          case TCond.oppWall
            cnd1 = getTranslation(l, "opponentWall")
          case TCond.oppTower
            cnd1 = getTranslation(l, "opponentTower")
          case TCond.diffStone, TCond.diffCrystal, TCond.diffCreature
            cnd1 = getTranslation(l, "differenceResources", res)
          case TCond.diffStoneProd, TCond.diffCrystalProd, TCond.diffCreatureProd
            cnd1 = getTranslation(l, "differenceProduction", res)
          case TCond.diffWall
            cnd1 = getTranslation(l, "differenceWall")
          case TCond.diffTower
            cnd1 = getTranslation(l, "differenceTower")
          case TCond.diffOwnBuilding
            cnd1 = getTranslation(l, "differenceOwnBuilding")
          case TCond.diffOppBuilding
            cnd1 = getTranslation(l, "differenceOpponentBuilding")
        end select
        select case c->effect(i).cond2
          case TCond.ownStone,    TCond.ownStoneProd,    TCond.oppStone,    TCond.oppStoneProd
            res = getTranslation(l, "stones")
          case TCond.ownCrystal,  TCond.ownCrystalProd,  TCond.oppCrystal,  TCond.oppCrystalProd
            res = getTranslation(l, "crystals")
          case TCond.ownCreature, TCond.ownCreatureProd, TCond.oppCreature, TCond.oppCreatureProd
            res = getTranslation(l, "creatures")
        end select
        select case c->effect(i).cond2
          case TCond.ownStone, TCond.ownCrystal, TCond.ownCreature
            cnd2 = getTranslation(l, "ownResources", res)
          case TCond.ownStoneProd, TCond.ownCrystalProd, TCond.ownCreatureProd
            cnd2 = getTranslation(l, "ownProduction", res)
          case TCond.ownWall
            cnd2 = getTranslation(l, "ownWall")
          case TCond.ownTower
            cnd2 = getTranslation(l, "ownTower")
          case TCond.oppStone, TCond.oppCrystal, TCond.oppCreature
            cnd2 = getTranslation(l, "opponentResources", res)
          case TCond.oppStoneProd, TCond.oppCrystalProd, TCond.oppCreatureProd
            cnd2 = getTranslation(l, "opponentProduction", res)
          case TCond.oppWall
            cnd2 = getTranslation(l, "opponentWall")
          case TCond.oppTower
            cnd2 = getTranslation(l, "opponentTower")
          case TCond.diffStone, TCond.diffCrystal, TCond.diffCreature
            cnd2 = getTranslation(l, "differenceResources", res)
          case TCond.diffStoneProd, TCond.diffCrystalProd, TCond.diffCreatureProd
            cnd2 = getTranslation(l, "differenceProduction", res)
          case TCond.diffWall
            cnd2 = getTranslation(l, "differenceWall")
          case TCond.diffTower
            cnd2 = getTranslation(l, "differenceTower")
          case TCond.diffOwnBuilding
            cnd1 = getTranslation(l, "differenceOwnBuilding")
          case TCond.diffOppBuilding
            cnd1 = getTranslation(l, "differenceOpponentBuilding")
          case else
            cnd2 = str(c->effect(i).compValue)
        end select
        select case c->effect(i).comp
          case TComp.equal   : cmp = getTranslation(l, "equal")
          case TComp.greater : cmp = getTranslation(l, "greater")
          case TComp.lower   : cmp = getTranslation(l, "lower")
        end select
        center posX, posY, getTranslation(l, "if", cnd1, cnd2, cmp),,, shortSpacing
        posY += shortSpacing
        center posX, posY, cardInfoText(c->effect(i)),,, shortSpacing
        if c->effect(i).effectTypeAlt <> TEffectType.none then
          posY += shortSpacing
          center posX, posY, getTranslation(l, "else") & " " & cardInfoText(c->effect(i), -1),,, shortSpacing
        end if
        posY += spacing
      end if
    next
  end if
  if c->special and Special.again then
    select case c->special and (Special.stone or Special.crystal or Special.creature)
      case Special.stone    : res = getTranslation(l, "stones")
      case Special.crystal  : res = getTranslation(l, "crystals")
      case Special.creature : res = getTranslation(l, "creatures")
      case else             : res = ""
    end select
    if res = "" then
      center posX, posY, getTranslation(l, "infoAgain")
    else
      center posX, posY, getTranslation(l, "infoAgainSpecial", res)
    end if
    posY += spacing
  end if
end sub

function cardInfoText(effect as TEffect, showAlt as integer = 0) as string
  dim as TEffectType e
  if showAlt then
    if len(effect.descAlt) then return effect.descAlt
    e = effect.effectTypeAlt
  else
    if len(effect.desc) then return effect.desc
    e = effect.effectType
  end if
  dim as string res
  dim as integer p = iif(showAlt, effect.powerAlt, effect.power)
  select case e
    case TEffectType.changeOwnStone,     TEffectType.changeOwnStoneProd,  _
         TEffectType.changeOppStone,     TEffectType.changeOppStoneProd,  _
         TEffectType.changeBothStone,    TEffectType.changeBothStoneProd, _
         TEffectType.stealStone,         TEffectType.stealStoneProd
      res = getTranslation(l, "stones")
    case TEffectType.changeOwnCrystal,   TEffectType.changeOwnCrystalProd,  _
         TEffectType.changeOppCrystal,   TEffectType.changeOppCrystalProd,  _
         TEffectType.changeBothCrystal,  TEffectType.changeBothCrystalProd, _
         TEffectType.stealCrystal,       TEffectType.stealCrystalProd
      res = getTranslation(l, "crystals")
    case TEffectType.changeOwnCreature,  TEffectType.changeOwnCreatureProd,  _
         TEffectType.changeOppCreature,  TEffectType.changeOppCreatureProd,  _
         TEffectType.changeBothCreature, TEffectType.changeBothCreatureProd, _
         TEffectType.stealCreature,      TEffectType.stealCreatureProd
      res = getTranslation(l, "creatures")
  end select
  select case e
    case TEffectType.changeOwnStone, TEffectType.changeOwnCrystal, TEffectType.changeOwnCreature
      if p > 0 then
        return getTranslation(l, "infoSelfGetResources", str(p), res)
      else
        return getTranslation(l, "infoSelfLoseResources", str(-p), res)
      end if
    case TEffectType.changeOwnStoneProd, TEffectType.changeOwnCrystalProd, TEffectType.changeOwnCreatureProd
      if p > 0 then
        return getTranslation(l, "infoSelfGetProduction", str(p), res)
      else
        return getTranslation(l, "infoSelfLoseProduction", str(-p), res)
      end if
    case TEffectType.changeOppStone, TEffectType.changeOppCrystal, TEffectType.changeOppCreature
      if p > 0 then
        return getTranslation(l, "infoOpponentGetResources", str(p), res)
      else
        return getTranslation(l, "infoOpponentLoseResources", str(-p), res)
      end if
    case TEffectType.changeOppStoneProd, TEffectType.changeOppCrystalProd, TEffectType.changeOppCreatureProd
      if p > 0 then
        return getTranslation(l, "infoOpponentGetProduction", str(p), res)
      else
        return getTranslation(l, "infoOpponentLoseProduction", str(-p), res)
      end if
    case TEffectType.changeBothStone, TEffectType.changeBothCrystal, TEffectType.changeBothCreature
      if p > 0 then
        return getTranslation(l, "infoBothGetResources", str(p), res)
      else
        return getTranslation(l, "infoBothLoseResources", str(-p), res)
      end if
    case TEffectType.changeBothStoneProd, TEffectType.changeBothCrystalProd, TEffectType.changeBothCreatureProd
      if p > 0 then
        return getTranslation(l, "infoBothGetProduction", str(p), res)
      else
        return getTranslation(l, "infoBothLoseProduction", str(-p), res)
      end if
    case TEffectType.stealStone, TEffectType.stealCrystal, TEffectType.stealCreature
      if p > 0 then
        return getTranslation(l, "infoStealResources", str(p), res)
      else
        return getTranslation(l, "infoGiveResources", str(-p), res)
      end if
    case TEffectType.stealStoneProd, TEffectType.stealCrystalProd, TEffectType.stealCreatureProd
      if p > 0 then
        return getTranslation(l, "infoStealProduction", str(p), res)
      else
        return getTranslation(l, "infoGiveProduction", str(-p), res)
      end if
    case TEffectType.changeOwnWall
      if p > 0 then
        return getTranslation(l, "infoSelfBuildWall", str(p))
      else
        return getTranslation(l, "infoSelfDamageWall", str(-p))
      end if
    case TEffectType.changeOppWall
      if p > 0 then
        return getTranslation(l, "infoOpponentBuildWall", str(p))
      else
        return getTranslation(l, "infoOpponentDamageWall", str(-p))
      end if
    case TEffectType.changeBothWall
      if p > 0 then
        return getTranslation(l, "infoBothBuildWall", str(p))
      else
        return getTranslation(l, "infoBothDamageWall", str(-p))
      end if
    case TEffectType.changeOwnTower
      if p > 0 then
        return getTranslation(l, "infoSelfBuildTower", str(p))
      else
        return getTranslation(l, "infoSelfDamageTower", str(-p))
      end if
    case TEffectType.changeOppTower
      if p > 0 then
        return getTranslation(l, "infoOpponentBuildTower", str(p))
      else
        return getTranslation(l, "infoOpponentDamageTower", str(-p))
      end if
    case TEffectType.changeBothTower
      if p > 0 then
        return getTranslation(l, "infoBothBuildTower", str(p))
      else
        return getTranslation(l, "infoBothDamageTower", str(-p))
      end if
    case TEffectType.ownDamage  : return getTranslation(l, "infoSelfDamage", str(p))
    case TEffectType.oppDamage  : return getTranslation(l, "infoOpponentDamage", str(p))
    case TEffectType.bothDamage : return getTranslation(l, "infoBothDamage", str(p))
  end select
  return ""
end function

sub center(x as integer, byref y as integer, s as string, col as uinteger = &hffffff, _
           max_ as integer = 45, spacing as integer = 10)
  center(0, x, y, s, col, max_, spacing)
end sub

sub center(img as FB.Image ptr, x as integer, byref y as integer, s as string, col as uinteger = &hffffff, _
           max_ as integer = 45, spacing as integer = 10)
  dim as integer search = -1, plus
  dim as string tempString = s
  do while len(tempstring)
    plus = 2
    search = instr(tempString, "\n")
    if search = 0 then search = len(tempstring)+1
    if search > max_ + 1 then
      search = instrrev(tempstring, " ", max_)
      if search = 0 then tempstring = left(tempstring, max_) : search = max_ + 1
      plus = 1
    end if
    draw string img, (x - 4*(search-1), y), left(tempString, search-1), col
    tempString = mid(tempString, search + plus)
    if len(tempstring) then y += spacing
  loop
end sub

function colorOfEffect(eff as TEffectType) as uinteger
  select case eff
    case changeOwnStone,     changeOwnStoneProd,     changeOppStone,    changeOppStoneProd, _
        changeBothStone,    changeBothStoneProd,    stealStoneProd,    stealStone
      return ColorStone
    case changeOwnCrystal,   changeOwnCrystalProd,   changeOppCrystal,  changeOppCrystalProd, _
        changeBothCrystal,  changeBothCrystalProd,  stealCrystalProd,  stealCrystal
      return ColorCrystal
    case changeOwnCreature,  changeOwnCreatureProd,  changeOppCreature, changeOppCreatureProd, _
        changeBothCreature, changeBothCreatureProd, stealCreatureProd, stealCreature
      return ColorCreature
    case else
      return &hffffff
  end select
end function

sub drawScreen(player as TPlayer, opponent as TPlayer, spec as integer)
  dim as uinteger col
  dim as integer cost, spacing = 20, height
  dim as string tempString
  dim as FB.Image ptr tableImg
  screenset 1, 0
  cls
  
  'ressources 1
  center 50,  15, getTranslation(l, "player")
  line (5,  35)-step(90, 140), ColorStone, b
  line (6,  36)-step(88, 138), 0, bf
  center 53,  60, getTranslation(l, "stones")
  center 53, 100, str(player.stone)
  center 53, 120, "(+" & player.pStone & ")"
  height = (138*player.stone) \ setting.maxStone
  if height > 138 then height = 138
  line (5, 174)-step(5, -height), ColorStone, bf

  line (5, 185)-step(90, 140), ColorCrystal, b
  line (6, 186)-step(88, 138), 0, bf
  center 53, 210, getTranslation(l, "crystals")
  center 53, 250, str(player.crystal)
  center 53, 270, "(+" & player.pCrystal & ")"
  height = (138*player.crystal) \ setting.maxCrystal
  if height > 138 then height = 138
  line (5, 324)-step(5, -height), ColorCrystal, bf

  line (5, 335)-step(90, 140), ColorCreature, b
  line (6, 336)-step(88, 138), 0, bf
  center 53, 360, getTranslation(l, "creatures")
  center 53, 400, str(player.creature)
  center 53, 420, "(+" & player.pCreature & ")"
  height = (138*player.creature) \ setting.maxCreature
  if height > 138 then height = 138
  line (5, 474)-step(5, -height), ColorCreature, bf

  ' ressources 2
  center 747,  15, getTranslation(l, "opponent")
  line (705,  35)-step(90, 140), ColorStone, b
  line (706,  36)-step(88, 138), 0, bf
  center 747,  60, getTranslation(l, "stones")
  center 747, 100, str(opponent.stone)
  center 747, 120, "(+" & opponent.pStone & ")"
  height = (138*opponent.stone) \ setting.maxStone
  if height > 138 then height = 138
  line (789, 174)-step(5, -height), ColorStone, bf

  line (705, 185)-step(90, 140), ColorCrystal, b
  line (706, 186)-step(88, 138), 0, bf
  center 747, 210, getTranslation(l, "crystals")
  center 747, 250, str(opponent.crystal)
  center 747, 270, "(+" & opponent.pCrystal & ")"
  height = (138*opponent.crystal) \ setting.maxCrystal
  if height > 138 then height = 138
  line (789, 324)-step(5, -height), ColorCrystal, bf

  line (705, 335)-step(90, 140), ColorCreature, b
  line (706, 336)-step(88, 138), 0, bf
  center 747, 360, getTranslation(l, "creatures")
  center 747, 400, str(opponent.creature)
  center 747, 420, "(+" & opponent.pCreature & ")"
  height = (138*opponent.creature) \ setting.maxCreature
  if height > 138 then height = 138
  line (789, 474)-step(5, -height), ColorCreature, bf

  ' player's cards
  dim as FB.Image ptr img
  for i as integer = 0 to 5
    img = cardImg(player.deck(player.card(i)), player, opponent, 1)
    put (i*100+100, 450), img, pset
    if playable(player, i, spec) = 0 then put (i*100+100, 450), grayImg, alpha
  next

  ' tower and wall 1
  height = iif(player.tower < setting.maxTower, player.tower, setting.maxTower)*300
  line (120, 400)-step(50, -height\setting.maxTower), &h555555, b
  line -step(  5,   0), &h555555
  line -step(  0, -10), &h555555
  line -step(-25, -25), &h555555
  line -step(-10,   0), &h555555
  line -step(-25,  25), &h555555
  line -step(  0,  10), &h555555
  line -step(  5,   0), &h555555
  paint step(0, -1), &h333333, &h555555
  if height\setting.maxTower > 1 then paint (121, 399), setting.fillTower, &h555555
  center 145, 410, str(player.tower)
  height = iif(player.wall < setting.maxTower, player.wall, setting.maxTower)*300
  line (190, 400)-step(16, -height\setting.maxTower), &hff7700, b
  if height\setting.maxTower > 1 then paint (191, 398), setting.fillWall,  &hff7700
  center 198, 410, str(player.wall)

  ' tower and wall 2
  height = iif(opponent.tower < setting.maxTower, opponent.tower, setting.maxTower)*300
  line (630, 400)-step(50, -height\setting.maxTower), &h555555, b
  line -step(  5,   0), &h555555
  line -step(  0, -10), &h555555
  line -step(-25, -25), &h555555
  line -step(-10,   0), &h555555
  line -step(-25,  25), &h555555
  line -step(  0,  10), &h555555
  line -step(  5,   0), &h555555
  paint step(0, -1), &h333333, &h555555
  if height\setting.maxTower > 1 then paint (631, 399), setting.fillTower, &h555555
  center 655, 410, str(opponent.tower)
  height = iif(opponent.wall < setting.maxTower, opponent.wall, setting.maxTower)*300
  line (594, 400)-step(16, -height\setting.maxTower), &hff7700, b
  if height\setting.maxTower > 1 then paint (609, 398), setting.fillWall,  &hff7700
  center 602, 410, str(opponent.wall)

  ' played Cards
  screensync
  screencopy 1, 0
  screenset 0, 0
  put (150, 10), playedCards, trans
end sub

sub makeTurn(player as TPlayer, opponent as TPlayer, tablenumber as integer, spec as integer)
  dim as string key, msg
  dim as integer mouseX, mouseY, mouseB, mouseOver
  do
    do
      getmouse mouseX, mouseY,, mouseB
      key = inkey
      if key = chr(255, 107) then
        myClient.sendCommand TCommand.withdraw
        exit sub
      end if
      sleep 1
    loop until mouseB = 0
    line (250, 400)-step(299, 20), 0, bf
    center 400, 390, getTranslation(l, "messagePlayCard")
    center 400, 410, getTranslation(l, "messageRightButton")
    mouseOver = 0
    do
      getmouse mouseX, mouseY,, mouseB
      key = inkey
      if key = chr(255, 107) then
        myClient.sendCommand TCommand.withdraw
        exit sub
      end if
      if mouseY < 450 then
        if mouseOver > 0 then
          mouseOver = 0
          cardInfo 0
          center 400, 390, getTranslation(l, "messagePlayCard")
          center 400, 410, getTranslation(l, "messageRightButton")
        end if
      elseif mouseOver <> mouseX \ 100 and (mouseX \ 100 < 7 or mouseOver > 0) then
        mouseOver = mouseX \ 100
        if mouseOver > MAXCARDS then mouseOver = 0
        if mouseOver = 0 then
          cardInfo 0
          center 400, 390, getTranslation(l, "messagePlayCard")
          center 400, 410, getTranslation(l, "messageRightButton")
        else
          cardInfo @player.deck(player.card(mouseOver-1))
        end if
      end if
      sleep 1
    loop until mouseB = 1 or mouseB = 2
    if mouseY < 450 or mouseY > 585 or mouseX < 100 or mouseX > 700 then
      do
        getmouse mouseX, mouseY,, mouseB
        sleep 1
      loop until mouseB = 0
      continue do
    end if
    dim as integer cardnumber = mouseX \ 100 - 1
    if tablenumber = 0 then
      line playedCards, (0, 0)-step(499, 449), &hff00ff, bf
      drawScreen player, opponent, spec
    end if
    if mouseB = 1 then
      if playable(player, cardnumber, spec) = 0 then continue do
      myClient.sendCommand TCommand.playCard, chr(cardnumber)
      move cardnumber, tablenumber
      exit do
    else
      myClient.sendCommand TCommand.dropCard, chr(cardnumber)
      if playable(player, cardnumber, spec) then put (100*cardnumber+100, 450), grayImg, alpha
      move cardnumber, tablenumber
      exit do
    end if
  loop
end sub

sub move(cardnumber as integer, tablenumber as integer)
  dim as any ptr pic = imagecreate(100, 140), bg = imagecreate(100, 140, 0)
  dim as integer startX = cardnumber*100 + 100, startY = 450
  dim as integer endX = 150 + 100*(tablenumber mod 5), endY = 10 + 25*(tablenumber \ 5)
  get (startX, startY)-step(99, 139), pic
  line (startX, startY)-step(99, 139), 0, bf
  for i as integer = 0 to 9
    screenlock
    put (startX + (endX-startX)*i/10, startY + (endY-startY)*i/10), bg, pset
    get (startX + (endX-startX)*(i+1)/10, startY + (endY-startY)*(i+1)/10)-step(99, 139), bg
    put (startX + (endX-startX)*(i+1)/10, startY + (endY-startY)*(i+1)/10), pic, pset
    screenunlock
    sleep 50
  next
  put playedCards, (endX-150, endY-10), pic, pset
  imagedestroy pic
  imagedestroy bg
end sub

function playable(p as TPlayer, cardnumber as integer, spec as integer) as integer
  dim as TCard c = p.deck(p.card(cardnumber))
  if spec = (Special.again or Special.stone)    andalso c.costType <> TCond.ownStone    then return 0
  if spec = (Special.again or Special.crystal)  andalso c.costType <> TCond.ownCrystal  then return 0
  if spec = (Special.again or Special.creature) andalso c.costType <> TCond.ownCreature then return 0
  select case c.costType
    case TCond.ownStone    : if c.cost > p.stone    then return 0
    case TCond.ownCrystal  : if c.cost > p.crystal  then return 0
    case TCond.ownCreature : if c.cost > p.creature then return 0
  end select
  return -1
end function

function readMessageData as string
  dim ret as string, length as integer
  mutexlock mutex
  ret = dataBuffer
  dataBuffer = ""
  mutexunlock mutex
  return ret
end function
